% a program to plot the sets at each iteration of the algorithm

function [xx,yy,zz,regzz,bhat] = makeplot_ellipse(thresh,nn,tn,n,supp,theta0)

% some parameters fixed by inputs
t = size(supp,1);		% the support of x
d = size(supp,2);		% dimension of x
lb = zeros(d,1);		% lower bound of mesh
ub = zeros(d,1);		% upper bound of mesh

% some parameters you can adjust
width = zeros(d,2);		% how much +/- to go from the center theta
delta = .01; 		        % the granularity of the grid

   width(1,1) = 2.5;
   width(1,2) = 2.5;
   width(2,1) = .65;
   width(2,2) = .65;

   % set up the mesh
   for i = 1:d
       lb(i,1) = theta0(i,1) - width(i,1);
       ub(i,1) = theta0(i,1) + width(i,2);
   end
   [xx,yy] = meshgrid(lb(1,1):delta:ub(1,1),lb(2,1):delta:ub(2,1));

cpsdat = csvread('cps00_mf.csv');

% make the upper and lower bounds on the dependent variable
x = zeros(n,2);
y = zeros(n,1);
scale = 1.5;
x(:,1:2) = [ones(n,1) cpsdat(:,1)];
for i = 1:n
    if (cpsdat(i,3) > 150000 && cpsdat(i,4) > 25000)
       y(i,1) = 175000*scale;
    elseif (cpsdat(i,3) > 150000 && cpsdat(i,4) <= 25000)
       y(i,1) = 150000*scale + cpsdat(i,4);
    elseif (cpsdat(i,3) <= 150000 && cpsdat(i,4) > 25000)
       y(i,1) = cpsdat(i,3) + 25000*scale;
    else
       y(i,1) = cpsdat(i,3) + cpsdat(i,4);
    end
    y(i,1) = y(i,1)/(52*cpsdat(i,2));
end
y = log(y);

[bhat,bint,rhat,rint] = regress(y,x);

sighat = rhat'*rhat/n;

   % evaluate function at grid points
   zz = zeros(size(xx,1),size(xx,2));
   regzz = zeros(size(xx,1),size(xx,2));
   for j = 1:size(xx,1)
       for k = 1:size(xx,2)
	   zz(j,k) = obj([xx(j,k);yy(j,k)]);
       regzz(j,k) = (bhat - [xx(j,k);yy(j,k)])'*(x'*x)*(bhat - [xx(j,k);yy(j,k)])/sighat;
       end
   end

   % plot the contours of the function
   %[c,h] = contour(xx,yy,zz,thresh(6));
   %hold on;
   %[c,h] = contour(xx,yy,regzz,5.99);
   %grid on;

	% objective function
        function q = obj(theta)
        q = 0;
        for i = 1:t        
            q = q + nn(i,1) * (max((tn(i,1) - supp(i,:)*theta),0)^2 + min((tn(i,2) - supp(i,:)*theta),0)^2);
        end
        q = q/n;
        end

end
