% a program to plot the sets at each iteration of the algorithm

%function [xx,yy,zz,oldzz] = makeptwiseplot(B,nn,nb,tn,tb,n,supp,theta0)
function [xx,yy,zz] = makeptwiseplot(B,nn,nb,tn,tb,n,supp,theta0)

eps = zeros(B,1);

% some parameters fixed by inputs
t = size(supp,1);		% the support of x
d = size(supp,2);		% dimension of x
lb = zeros(d,1);		% lower bound of mesh
ub = zeros(d,1);		% upper bound of mesh

% some parameters you can adjust
width = zeros(d,2);		% how much +/- to go from the center theta
delta1 = .001;			% the granularity of the grid
delta2 = .0005;			% the granularity of the grid

   width(1,1) = .2;
   width(1,2) = .2;
   width(2,1) = .075;
   width(2,2) = .075;

   % set up the mesh
   for i = 1:d
       lb(i,1) = theta0(i,1) - width(i,1);
       ub(i,1) = theta0(i,1) + width(i,2);
   end
   [xx,yy] = meshgrid(lb(1,1):delta1:ub(1,1),lb(2,1):delta2:ub(2,1));

   % evaluate function at grid points
   zz = zeros(size(xx,1),size(xx,2));
   %oldzz = zeros(size(xx,1),size(xx,2));
   count = 0;
   size(xx,1)
   for j = 1:size(xx,1)
       count = count + 1
       for k = 1:size(xx,2)
	   zz(j,k) = obj([xx(j,k);yy(j,k)]);
	   %oldzz(j,k) = oldobj([xx(j,k);yy(j,k)]);
       end
   end

   % plot the contours of the function
   %[c,h] = contour(xx,yy,zz,[10^-1]);
   %hold on;
   %[c,h] = contour(xx,yy,oldzz,[.1020]);
   %grid on;

        % objective function
        function q = obj(theta)
	q = oldobj(theta) - subcrit(theta);
        end
         
	function ee = subcrit(theta)
        for m = 1:B
	    eps(m) = 0;
            for i = 1:t
                eps(m) = eps(m) + nb(i,m) * (max((tb(i,1,m) - supp(i,:)*theta),0)^2 + min((tb(i,2,m) - supp(i,:)*theta),0)^2);
            end
        end
        eps = sort(eps);
        ee = eps(ceil(.95*B))/n;
	end
	
        function qq = oldobj(theta)
        qq = 0;
        crit = 0;
        for i = 1:t
            qq = qq + nn(i,1) * (max((tn(i,1) - supp(i,:)*theta),0)^2 + min((tn(i,2) - supp(i,:)*theta),0)^2);
        end
	qq = qq/n;
	end

end
