function [fval,ef] = maxobj(eps,nb,nn,tb,tn,b,n,supp,theta0)
% eps = threshold for constraint
% nb = number of x_i = x_j for subsample
% nn = number of x_i = x_j for entire sample
% tb = tau of size b
% tn = tau of size n
% b = subsample size
% n = sample size
% supp = the support of x
% theta0 = starting value

% set optimization parameters, etc.
options = optimset('fmincon');
options = optimset(options,'MaxFunEvals', 2000);
options = optimset(options,'TolFun', 1e-5);
options = optimset(options,'TolCon', 1e-4);
options = optimset(options,'Display','off');
options = optimset(options,'LargeScale','off');
t = size(supp,1);

[x,fval,ef] = fmincon(@obj,theta0,[],[],[],[],[],[],@nlcon,options);

	% objective function
	function q = obj(theta)
	q = 0;
	for i = 1:t
	    q = q + nb(i,1) * (max((tb(i,1) - supp(i,:)*theta),0)^2 + min((tb(i,2) - supp(i,:)*theta),0)^2);
	end
	q = -q/b;
	end

	% the nonlinear contraint
	function [c,ceq] = nlcon(theta)
	ceq = 0;
	c = 0;
	for i = 1:t
	    c = c + nn(i,1) * (max((tn(i,1) - supp(i,:)*theta),0)^2 + min((tn(i,2) - supp(i,:)*theta),0)^2);
	end
	c = c/n - eps;
	end

end
